--- Creator: Jim Kroovy (https://www.youtube.com/c/JimKroovy)

--- Version: 1.0.0

--- Changelog: See download page, github repository or the relevent playlist on the above youtube channel

--- Comments:  From a background working In Unreal Engine and Blender with visual and python scripting i took to this like a murloc to water (Mrrrrgglllurrgllrrgl!) 
    ---        and it's great fun, as well as an honour, being able to expand on the legendary World of Warcraft which i have played since the year of its release :)

--- Notes:     A simple continuation of my quest for a more immersive World of Warcraft!

    ---        Known Issues: Some of these i will sort out at some point, some might be blizzard bugs that i cannot fix
    ---          Minimap indoor background disappears... (known blizzard bug, i'm exploring texture masking alternatives)
    ---          StoreFrame is restricted and i cannot find a way to set it's opacity...
    ---          Party frames alpha seems to reset itself sometimes...
    ---          Chat tabs sometimes flicker for a second when mousing over... (i need to overwrite their fading function still)
    ---          When changing between 1 or 2 exp bars the fill level frame pokes out to the right, it fixes itself soon after... (fixes on /reload or when update fires)

    ---        Other Add-ons: Anything that adds to or changes the user interface will likely be incompatible unless it is listed below
    ---          Immersive Character Needs (is my add-on so naturally it works with this)

----- OPTION VARIABLES -----
-- interface opacity when mouse is on/off each frame...
OnOpacity = 1.0
OffOpacity = 0.5
--local Combat_Opacity = 0.5
-- Experience bar width...
BarWidth = 470
-- tooltip opacity...
TooltipMenu_Opacity = 0.75
TooltipWorld_Opacity = 0.5
-- tool tip border...
TooltipBorder = false
TooltipToMouse = true
-- party frame size...
PartyScale = 1.0
PartyVertical = true
-- action bar layout...
ActionBarLayout = 'NUMERICAL'

----- FUNCTIONAL VARIABLES -----
IsAddonLoaded = false
IsLoggedIn = false
-- frame data dictionary...
FrameData = {}
-- default buttons/frames...
ActionButtons = {}

DefaultActionButtons = {ActionButton1, ActionButton2, ActionButton3, 
    ActionButton4, ActionButton5, ActionButton6, 
    ActionButton7, ActionButton8, ActionButton9, 
    ActionButton10, ActionButton11, ActionButton12}

MultiBarBottomLeftButtons = {MultiBarBottomLeftButton1, MultiBarBottomLeftButton2, MultiBarBottomLeftButton3, 
    MultiBarBottomLeftButton4, MultiBarBottomLeftButton5, MultiBarBottomLeftButton6, 
    MultiBarBottomLeftButton7, MultiBarBottomLeftButton8, MultiBarBottomLeftButton9, 
    MultiBarBottomLeftButton10, MultiBarBottomLeftButton11, MultiBarBottomLeftButton12}

MultiBarBottomRightButtons = {MultiBarBottomRightButton7, MultiBarBottomRightButton8, MultiBarBottomRightButton9, 
    MultiBarBottomRightButton10, MultiBarBottomRightButton11, MultiBarBottomRightButton12, 
    MultiBarBottomRightButton1, MultiBarBottomRightButton2, MultiBarBottomRightButton3, 
    MultiBarBottomRightButton4, MultiBarBottomRightButton5, MultiBarBottomRightButton6}

MultiBarLeftButtons = {MultiBarLeftButton1, MultiBarLeftButton2, MultiBarLeftButton3, 
    MultiBarLeftButton4, MultiBarLeftButton5, MultiBarLeftButton6, 
    MultiBarLeftButton7, MultiBarLeftButton8, MultiBarLeftButton9, 
    MultiBarLeftButton10, MultiBarLeftButton11, MultiBarLeftButton12}

MultiBarRightButtons = {MultiBarRightButton1, MultiBarRightButton2, MultiBarRightButton3, 
    MultiBarRightButton4, MultiBarRightButton5, MultiBarRightButton6, 
    MultiBarRightButton7, MultiBarRightButton8, MultiBarRightButton9, 
    MultiBarRightButton10, MultiBarRightButton11, MultiBarRightButton12}

MicroButtons = {CharacterMicroButton, SpellbookMicroButton, TalentMicroButton, AchievementMicroButton, QuestLogMicroButton, GuildMicroButton, LFDMicroButton, CollectionsMicroButton, EJMicroButton, StoreMicroButton, MainMenuMicroButton}
BagButtons = {MainMenuBarBackpackButton, CharacterBag0Slot, CharacterBag1Slot, CharacterBag2Slot, CharacterBag3Slot}
PartyFrames = {PartyMemberFrame1, PartyMemberFrame2, PartyMemberFrame3, PartyMemberFrame4}
ChatFrames = {QuickJoinToastButton, ChatFrameMenuButton, ChatFrameChannelButton, ChatFrame1Tab, ChatFrame1, ChatFrame1EditBox}
-- default frames that aren't always open...
PopFrames = {CharacterFrame, SpellBookFrame, PlayerTalentFrame, AchievmentFrame, WorldMapFrame, 
CommunitiesFrame, PVEFrame, CollectionsJournal, EncounterJournal, CalendarFrame, ChannelFrame, FriendsFrame, 
GarrisonLandingPage, BFAMissionFrame, TimerTracker, QuickJoinToastButton, LFGDungeonReadyPopUp, GossipFrame, 
MerchantFrame, ZoneTextFrame, CastingBarFrame, TalkingHeadFrame, InspectFrame, UIWidgetTopCenterContainerFrame, LootFrame} 
-- default frames that aren't always open but can be iterated over...
IterPopFrames = {"ContainerFrame", "StaticPopup"}

-- my action bar frames...
IUI_ActionBar = CreateFrame("Frame","IUI_ActionBar",UIParent)
-- modular at some point???
--local IUI_ActionBarBlock1 = CreateFrame("Frame","IUI_ActionBarBlock1",IUI_ActionBar)
--local IUI_ActionBarBlock2 = CreateFrame("Frame","IUI_ActionBarBlock2",IUI_ActionBar)
--local IUI_ActionBarBlock3 = CreateFrame("Frame","IUI_ActionBarBlock3",IUI_ActionBar)
--local IUI_ActionBarBlock4 = CreateFrame("Frame","IUI_ActionBarBlock4",IUI_ActionBar)
ActionBarAnchors = {}
-- my minimap frame...
IUI_MiniMap = CreateFrame("Frame","IUI_MiniMap",UIParent)
MiniMapAnchors = {}
-- my quest tracker frame...
IUI_QuestTracker = CreateFrame("Frame","IUI_QuestTracker",UIParent)
QuestAnchors = {}
-- my player frame...
IUI_Player = CreateFrame("Frame","IUI_Player",UIParent)
PlayerAnchors = {}
-- my target frame...
IUI_Target = CreateFrame("Frame","IUI_Target",UIParent)
TargetAnchors = {}
-- my party frame...
IUI_Party = CreateFrame("Frame","IUI_Party",UIParent)
PartyAnchors = {}
-- buffs frame...
IUI_Buffs = CreateFrame("Frame","IUI_Buffs",UIParent)
BuffAnchors = {}
-- my exp bars frame...
IUI_Bars = CreateFrame("Frame","IUI_Bars",UIParent)
BarAnchors = {}
-- my menus frame...
IUI_Menus = CreateFrame("Frame","IUI_Menus",UIParent)
MenuAnchors = {}
-- my bags frame...
IUI_Bags = CreateFrame("Frame","IUI_Bags",UIParent)
BagAnchors = {}

-- my chat frame...
IUI_Chat = CreateFrame("Frame","IUI_Chat",UIParent)

-- default points...
QuestTracker_Point = {"TOPLEFT", IUI_QuestTracker, "TOPLEFT", 0, 0}
VehicleSeat_Point = {"LEFT", PlayerFrame, "RIGHT", 0, -5}
--local VehicleExit_Point = {"LEFT", PlayerFrame, "RIGHT", 0, -5}

StatusBar_Point = nil