-- one frame to event them all!
IUI_EventFrame = CreateFrame("Frame")
--IUI_EventFrame:RegisterAllEvents()
IUI_EventFrame:RegisterEvent("ADDON_LOADED")
IUI_EventFrame:RegisterEvent("PLAYER_LOGIN")
IUI_EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
IUI_EventFrame:RegisterEvent("PLAYER_LOGOUT")
IUI_EventFrame:RegisterEvent("MINIMAP_UPDATE_ZOOM")
IUI_EventFrame:RegisterEvent("UPDATE_ALL_UI_WIDGETS")

--IUI_EventFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
--IUI_EventFrame:RegisterEvent("ZONE_CHANGED")
--IUI_EventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
IUI_EventFrame:SetScript("OnEvent", function(self, event, arg1)
    if event == "ADDON_LOADED" and arg1 == "ImmersiveUserInterface" then
        print("ADDON_LOADED : Immersive User Interface")
        if IUI_Account_Table == nil then
            IUI_Account_Table = {
                ['ACTIONBAR'] = {['LAYOUT'] = 'NUMERICAL'},
                ['TOOLTIP'] = {['MENU_ALPHA'] = 0.75, ['WORLD_ALPHA'] = 0.5, ['USE_BORDER'] = false, ['TO_MOUSE'] = true},
                ['PARTY'] = {['PARTY_SCALE'] = 1.0, ['PARTY_VERTICAL'] = true},
                ['OPACITY'] = {['MOUSE_ON'] = 1.0, ['MOUSE_OFF'] = 0.5},
            }
        end
        -- overides the default tooltip fading
        GameTooltip:HookScript("OnShow", function()
            if GetMouseFocus() == WorldFrame then 
                GameTooltip:SetAlpha(IUI_Account_Table['TOOLTIP']['WORLD_ALPHA'])
            else
                GameTooltip:SetAlpha(IUI_Account_Table['TOOLTIP']['MENU_ALPHA'])
            end
        end)
        if TooltipToMouse then
            -- anchor tooltip to mouse...
            hooksecurefunc("GameTooltip_SetDefaultAnchor", function(tooltip, parent)
                tooltip:SetOwner(parent, "ANCHOR_CURSOR")
                SetTooltip(tooltip)
                --tooltip.default = 1
            end)
        end

        -- Not sure i can be bothered to implement the minimap texture swapping work around... (workflow involves extracting textures and writing a script to iterate opacity for them all)
        
        --Minimap:SetBlipTexture("Interface\\AddOns\\ImmersiveUserInterface\\MiniMap_Icons\\IUI_MiniMapIconAtlas_100")
        --Minimap:SetMaskTexture("Interface\\AddOns\\ImmersiveUserInterface\\MiniMap_Masks\\IUI_MiniMapMask_100")
        --Minimap:SetPlayerTexture("Interface\\AddOns\\ImmersiveUserInterface\\MiniMap_Arrows\\IUI_MiniMapVignetteArrow_100")
        --Minimap:SetPOIArrowTexture("Interface\\AddOns\\ImmersiveUserInterface\\MiniMap_Arrows\\IUI_MiniMapArrow_100")
        --Minimap:SetStaticPOIArrowTexture("Interface\\AddOns\\ImmersiveUserInterface\\MiniMap_Arrows\\IUI_MiniMapArrow_100")
        --Minimap:SetCorpsePOIArrowTexture("Interface\\AddOns\\ImmersiveUserInterface\\MiniMap_Arrows\\IUI_MiniMapCorpseArrow_100")
        --Minimap:SetIconTexture("Interface\\AddOns\\ImmersiveUserInterface\\MiniMap_Arrows\\IUI_MiniMapCorpseArrow_100")
        
        --Minimap:SetArchBlobInsideAlpha(alpha)
        --Minimap:SetArchBlobInsideTexture(textureFile)
        --Minimap:SetArchBlobOutsideAlpha(alpha)
        --Minimap:SetArchBlobOutsideTexture(textureFile)
        --Minimap:SetArchBlobRingAlpha(alpha)
        --Minimap:SetArchBlobRingScalar(scalar)
        --Minimap:SetArchBlobRingTexture(textureFile)
        --Minimap:UpdateBlips()
        
        --Minimap:SetQuestBlobInsideAlpha(alpha)
        --Minimap:SetQuestBlobInsideTexture(textureFile)
        --Minimap:SetQuestBlobOutsideAlpha(alpha)
        --Minimap:SetQuestBlobOutsideSelectedTexture(textureFile)
        --Minimap:SetQuestBlobOutsideTexture(textureFile)
        --Minimap:SetQuestBlobRingAlpha(alpha)
        --Minimap:SetQuestBlobRingScalar(scalar)
        --Minimap:SetQuestBlobRingTexture(textureFile)
        
        --Minimap:SetTaskBlobInsideAlpha(alpha)
        --Minimap:SetTaskBlobInsideTexture(textureFile)
        --Minimap:SetTaskBlobOutsideAlpha(alpha)
        --Minimap:SetTaskBlobOutsideSelectedTexture("file")
        --Minimap:SetTaskBlobOutsideTexture(textureFile)
        --Minimap:SetTaskBlobRingAlpha(alpha)
        --Minimap:SetTaskBlobRingScalar(scalar)
        --Minimap:SetTaskBlobRingTexture(textureFile)

        IsAddonLoaded = true
    elseif event == "PLAYER_LOGIN" then
        IsLoggedIn = true
        --print("PLAYER_LOGIN") 
    elseif event == "PLAYER_ENTERING_WORLD" or event == "UPDATE_ALL_UI_WIDGETS" then
        -- using a timer ensures we have loaded everything...
        C_Timer.After(3, function()
            IUI_UpdateInterface()
            --print("IUI_UPDATE")
        end)
    elseif event == "PLAYER_LOGOUT" then
        print("PLAYER_LOGOUT")
    elseif event == "MINIMAP_UPDATE_ZOOM" then
        -- temporary fix for minimap alpha render bug...
        if IsIndoors() then
            Minimap:SetAlpha(1)
            Minimap:SetZoom(Minimap:GetZoom() + 1)
		    Minimap:SetZoom(Minimap:GetZoom() - 1)
        elseif MouseIsOver(IUI_MiniMap) then
            Minimap:SetAlpha(0.75)
        else
            Minimap:SetAlpha(0.5)
        end
    end
end)