function tGetIndex(table, value)
    local int = nil
    for i,v in pairs(table) do
        if v == value then
            int = i
            return int
        end
    end
    return int
end

function IUI_LoadMinimapCluster()
    IUI_MiniMap:SetFrameStrata("LOW")
    IUI_MiniMap:SetWidth(192)
    IUI_MiniMap:SetHeight(192)
    IUI_MiniMap:SetPoint("TOPRIGHT", 0, 0)
    MinimapCluster:ClearAllPoints()
    MinimapCluster:SetAllPoints(IUI_MiniMap)
    MiniMapAnchors[MinimapCluster] = {MinimapCluster:GetPoint()}
    Minimap:SetIgnoreParentAlpha(true)
    for i,frame in pairs{Minimap:GetChildren()} do
        frame:SetIgnoreParentAlpha(true)
    end
end

function IUI_LoadBuffsFrame()
    IUI_Buffs:SetWidth(35 * BuffFrame:GetNumChildren())
    IUI_Buffs:SetHeight(40)
    IUI_Buffs:SetPoint("TOPRIGHT", -205, -5)
    BuffFrame:ClearAllPoints()
    BuffFrame:SetAllPoints(IUI_Buffs)
    BuffAnchors[BuffFrame] = {BuffFrame:GetPoint()}
end

function IUI_LoadObjectiveTracker()
    IUI_QuestTracker:SetFrameStrata("LOW")
    IUI_QuestTracker:SetFrameLevel(2)
    IUI_QuestTracker:SetWidth(168)
    IUI_QuestTracker:SetHeight(800)
    IUI_QuestTracker:SetPoint("TOPRIGHT", -5, -192)
    ObjectiveTrackerFrame:ClearAllPoints()
    --ObjectiveTrackerFrame:SetPoint("TOPLEFT", IUI_QuestTracker, "TOPLEFT", 0, 0)
    ObjectiveTrackerFrame:SetAllPoints(IUI_QuestTracker)
    QuestAnchors[ObjectiveTrackerFrame] = {ObjectiveTrackerFrame:GetPoint()}
    ObjectiveTrackerFrame:SetScale(0.75)
end

function IUI_LoadPlayerFrame(FrameData)
    IUI_Player:SetWidth(232)
    IUI_Player:SetHeight(100)
    IUI_Player:SetPoint("BOTTOMLEFT", 0, 42)
    PlayerFrame:ClearAllPoints()
    PlayerFrame:SetPoint("TOPLEFT", IUI_Player, "TOPLEFT", 0, 0)
    PlayerAnchors[PlayerFrame] = {"TOPLEFT", IUI_Player, "TOPLEFT", 0, 0}
    VehicleSeatIndicator:ClearAllPoints()
    VehicleSeatIndicator:SetPoint("LEFT", PlayerFrame, "RIGHT", 0, -5)
    VehicleSeatIndicator:SetScale(0.75)
    PlayerAnchors[VehicleSeatIndicator] = {"LEFT", PlayerFrame, "RIGHT", 0, -5}
    DurabilityFrame:ClearAllPoints()
    DurabilityFrame:SetPoint("LEFT", PlayerFrame, "RIGHT", 20, 0)
    PlayerAnchors[DurabilityFrame] = {"LEFT", PlayerFrame, "RIGHT", 20, 0}
end

function IUI_LoadTargetFrame()
    IUI_Target:SetWidth(232)
    IUI_Target:SetHeight(100)
    IUI_Target:SetPoint("BOTTOMRIGHT", 0, 42)
    TargetFrame:ClearAllPoints()
    TargetFrame:SetPoint("TOPLEFT", IUI_Target, "TOPLEFT", 0, 0)
    TargetAnchors[TargetFrame] = {"TOPLEFT", IUI_Target, "TOPLEFT", 0, 0}
end

function IUI_LoadBarsFrame()
    IUI_Bars:SetWidth(BarWidth)
    IUI_Bars:SetHeight(35)
    IUI_Bars:SetPoint("BOTTOM", 46, -2)
    local TwoBar_Y = -6 -- -9
    local OneBar_Y = -3
    StatusTrackingBarManager.SingleBarLarge:ClearAllPoints()
    StatusTrackingBarManager.SingleBarLarge:SetWidth(BarWidth)
    if StatusTrackingBarManager.SingleBarLargeUpper:IsVisible() then
        StatusTrackingBarManager.SingleBarLarge:SetPoint("CENTER", IUI_Bars, "CENTER", 0, TwoBar_Y)
        BarAnchors[StatusTrackingBarManager.SingleBarLarge] = {"CENTER", IUI_Bars, "CENTER", TwoBar_Y}
    else
        StatusTrackingBarManager.SingleBarLarge:SetPoint("CENTER", IUI_Bars, "CENTER", 0, OneBar_Y)
        BarAnchors[StatusTrackingBarManager.SingleBarLarge] = {"CENTER", IUI_Bars, "CENTER", 0, OneBar_Y}
    end
    StatusTrackingBarManager.SingleBarLargeUpper:SetWidth(BarWidth - 2)
    -- the actual status bars are not named so iterating through them...
    for i,child in pairs({StatusTrackingBarManager:GetChildren()}) do
        for i2,child2 in pairs({child:GetChildren()}) do
            if child2:GetObjectType() == "StatusBar" then
                local _, tA, _, xA, yA = child2:GetPoint()
                local _, tB, _, xB, yB = tA:GetPoint()
                tA:ClearAllPoints()
                tA:SetWidth(BarWidth)
                tA:SetPoint("TOP", IUI_Bars, "TOP", xB, yB)
                child2:ClearAllPoints()
                child2:SetWidth(BarWidth - 4)
                child2:SetPoint("CENTER", tA, "CENTER", xA, yA)
            end
        end
    end
end

function IUI_LoadMenusFrame()
    IUI_Menus:SetWidth(230)
    IUI_Menus:SetHeight(28)
    IUI_Menus:SetPoint("BOTTOM", -307, 0)
    CharacterMicroButton:ClearAllPoints()
    CharacterMicroButton:SetPoint("TOPLEFT", IUI_Menus, "TOPLEFT", 0, 0)
    MenuAnchors[CharacterMicroButton] = {"TOPLEFT", IUI_Menus, "TOPLEFT", 0, 0}
    for i,micro in pairs(MicroButtons) do
        -- 28, 36
        micro:SetScale(0.8)
    end
end

function IUI_LoadBagsFrame()
    IUI_Bags:SetWidth(148)
    IUI_Bags:SetHeight(28)
    IUI_Bags:SetPoint("BOTTOM", 342, 0)
    MainMenuBarBackpackButton:ClearAllPoints()
    MainMenuBarBackpackButton:SetPoint("TOPRIGHT", IUI_Bags, "TOPRIGHT", 0, 0)
    BagAnchors[MainMenuBarBackpackButton] = {"TOPRIGHT", IUI_Bags, "TOPRIGHT", 0, 0}
    CharacterBag0Slot:SetPoint("RIGHT", MainMenuBarBackpackButton, "LEFT", -4, 0)
    BagAnchors[CharacterBag0Slot] = {"RIGHT", MainMenuBarBackpackButton, "LEFT", -4, 0}
    for i,bag in pairs(BagButtons) do
        --print(bag:GetSize())
        if i == 1 then
            bag:SetScale(0.65)
        else
            bag:SetScale(0.8)
        end
    end
end

function IUI_LoadPartyFrame()
    if PartyVertical then
        IUI_Party:SetWidth(80)
        IUI_Party:SetHeight((60 * GetNumGroupMembers()) - (5 * (GetNumGroupMembers() - 1)))
    else
        IUI_Party:SetWidth((80 * GetNumGroupMembers()) - (5 * (GetNumGroupMembers() - 1)))
        IUI_Party:SetHeight(60)
    end
    IUI_Party:SetPoint("TOPLEFT", 0, 0)
    PartyMemberFrame1:ClearAllPoints()
    PartyMemberFrame1:SetPoint("TOPLEFT", IUI_Party, "TOPLEFT", 5, -5)
    PartyAnchors[PartyMemberFrame1] = {"TOPLEFT", IUI_Party, "TOPLEFT", 5, -5}
    for i,member in pairs(PartyFrames) do
        --print(member:GetSize())
        member:SetScale(PartyScale)
        if not PartyVertical then
            if i ~= 1 then
                member:ClearAllPoints()
                member:SetPoint("LEFT", PartyFrames[i - 1], "RIGHT", 10, 0)
                PartyMemberAnchors[member] = {"LEFT", PartyFrames[i - 1], "RIGHT", 10, 0}
            end
        end
    end
end

-- Organises all the action buttons...
function IUI_LoadActionBar()
    IUI_ActionBar:SetWidth(840)
    IUI_ActionBar:SetHeight(168) --126
    IUI_ActionBar:SetPoint("BOTTOM", 0, 25)
    -- set up some iteration variables...
    local OffsetY = 84
    local RowCount = 5
    local RowLevel = 1
    local RowSpace = -42
    local RowIter = 1
    local BottomLeft, BottomRight, MultiLeft, MultiRight = GetActionBarToggles()
    local StancePetButtons = {}
    -- iterate through the action button layout...
    for block,buttons in pairs(IUI_ActionButtonBlocks["20 x 3"]) do
        local start = 0
        if block == "Block1" then
            start = 0
        elseif block == "Block2" then
            start = 42 * 5
        elseif block == "Block3" then
            start = 42 * 10
        elseif block == "Block4" then
            start = 42 * 15
        end
        for i,button in pairs(buttons) do
            RowIter = RowIter + 1
            --print(button:GetName())
            button:ClearAllPoints()
            if i > 10 then
                button:SetPoint("TOPLEFT", IUI_ActionBar, "TOPLEFT", start + (42 * (RowIter - 1)) - 42, -126)
                ActionBarAnchors[button] = {"TOPLEFT", IUI_ActionBar, "TOPLEFT", start + (42 * (RowIter - 1)) - 42, -126}
            elseif i > 5 then
                button:SetPoint("TOPLEFT", IUI_ActionBar, "TOPLEFT", start + (42 * (RowIter - 1)) - 42, -84)
                ActionBarAnchors[button] = {"TOPLEFT", IUI_ActionBar, "TOPLEFT", start + (42 * (RowIter - 1)) - 42, -84}
            else 
                button:SetPoint("TOPLEFT", IUI_ActionBar, "TOPLEFT", start + (42 * (RowIter - 1)) - 42, -42)
                ActionBarAnchors[button] = {"TOPLEFT", IUI_ActionBar, "TOPLEFT", start + (42 * (RowIter - 1)) - 42, -42}
            end
            if tGetIndex(ActionButtons, button) == nil then
                table.insert(ActionButtons, button)
            end
            if RowIter > RowCount then
                RowIter = 1
            end
        end
        RowIter = 1
    end
    -- move the up and down action bar swapping buttons...
    ActionBarUpButton:ClearAllPoints()
    ActionBarUpButton:SetPoint("TOPLEFT", IUI_ActionBar, "TOPLEFT", -25, -41)
    ActionBarAnchors[ActionBarUpButton] = {"TOPLEFT", IUI_ActionBar, "TOPLEFT", -25, -41}
    if tGetIndex(ActionButtons, ActionBarUpButton) == nil then
        table.insert(ActionButtons, ActionBarUpButton)
    end
    ActionBarDownButton:ClearAllPoints()
    ActionBarDownButton:SetPoint("TOPLEFT", IUI_ActionBar, "TOPLEFT", -25, -58)
    ActionBarAnchors[ActionBarDownButton] = {"TOPLEFT", IUI_ActionBar, "TOPLEFT", -25, 1}
    if tGetIndex(ActionButtons, ActionBarDownButton) == nil then
        table.insert(ActionButtons, ActionBarDownButton)
    end
    -- re-organise stance, pet and possessed action bars...
    if (StanceBarFrame and StanceBarFrame:IsShown()) or (PetActionBarFrame and PetActionBarFrame:IsShown()) then
        if (StanceBarFrame and StanceBarFrame:IsShown()) and (PetActionBarFrame and PetActionBarFrame:IsShown()) then
            StancePetButtons = {StanceBarFrame:GetChildren(), PetActionBarFrame:GetChildren()}
        elseif StanceBarFrame and StanceBarFrame:IsShown() then
            StancePetButtons = {StanceBarFrame:GetChildren()}
        elseif PetActionBarFrame and PetActionBarFrame:IsShown() then
            StancePetButtons = {PetActionBarFrame:GetChildren()}
        end
        if #StancePetButtons > 0 then
            for i,button in pairs(StancePetButtons) do
                button:ClearAllPoints() 
                button:SetPoint("TOPLEFT", IUI_ActionBar, "TOPLEFT", 42 * (i - 1) + 44, 0)
                ActionBarAnchors[button] = {"TOPLEFT", IUI_ActionBar, "TOPLEFT", 42 * (i - 1) + 44, 0}
                if tGetIndex(ActionButtons, button) == nil then
                    table.insert(ActionButtons, button)
                end
            end
        end
    end
    -- sort out the vehicle leave button...
    MainMenuBarVehicleLeaveButton:ClearAllPoints()
    MainMenuBarVehicleLeaveButton:SetPoint("TOPLEFT", IUI_ActionBar, "TOPLEFT", 0, 0)
    ActionBarAnchors[ExtraActionBarFrame] = {"TOPLEFT", IUI_ActionBar, "TOPLEFT", 0, 0}
    --MainMenuBarVehicleLeaveButton:SetHitRectInsets(-60, 60, -50, 50)
    if tGetIndex(ActionButtons, MainMenuBarVehicleLeaveButton) == nil then
        table.insert(ActionButtons, MainMenuBarVehicleLeaveButton)
    end
    --for i,child in pairs({MainMenuBarVehicleLeaveButton:GetRegions()}) do
        --child:ClearAllPoints()
        --child:SetPoint("TOPLEFT", MainMenuBarVehicleLeaveButton, "TOPLEFT", -60, 50)
        --child:SetSize(35, 35)
    --end
    -- aaaand sort out the extra action button frame...
    ExtraActionBarFrame:ClearAllPoints()
    ExtraActionBarFrame:SetPoint("BOTTOM", IUI_ActionBar, "TOP", 0, 0)
    ActionBarAnchors[ExtraActionBarFrame] = {"BOTTOM", IUI_ActionBar, "TOP", 0, 0}
    if tGetIndex(ActionButtons, ExtraActionBarFrame) == nil then
        table.insert(ActionButtons, ExtraActionBarFrame)
    end
end

function IUI_UpdateInterface()
    -- kill the original action bar... (stops it taking over the mouse when bags are open)
    MainMenuBar:EnableMouse(false)
    -- kill the action bar gryphons...
    MainMenuBarArtFrame:EnableMouse(false)
    for i,region in pairs({MainMenuBarArtFrame:GetRegions()}) do
        region:SetAlpha(0)
    end
    -- kill the action bar background...
    MainMenuBarArtFrameBackground:EnableMouse(false)
    for i,region in pairs({MainMenuBarArtFrameBackground:GetRegions()}) do
        region:SetTexture("")
    end
    -- kill the micro button and bags background...
    MicroButtonAndBagsBar:EnableMouse(false)
    for i,region in pairs({MicroButtonAndBagsBar:GetRegions()}) do
        region:SetTexture("")
    end
    for i,region in pairs({PetActionBarFrame:GetRegions()}) do
        --print(region:GetName())
        region:SetTexture("")
        --region:SetIgnoreParentAlpha(true)
    end
    UIErrorsFrame:SetAlpha(0)
    OnOpacity = IUI_Account_Table['OPACITY']['MOUSE_ON']
    OffOpacity = IUI_Account_Table['OPACITY']['MOUSE_OFF']
    IUI_LoadPlayerFrame()
    FrameData[IUI_Player] = {["IsMouseOn"] = false, ["InCombat"] = true, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {PlayerFrame, VehicleSeatIndicator, DurabilityFrame}, ["Anchors"] = PlayerAnchors}
    IUI_LoadTargetFrame()
    FrameData[IUI_Target] = {["IsMouseOn"] = false, ["InCombat"] = true, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {TargetFrame}, ["Anchors"] = TargetAnchors}
    IUI_LoadActionBar()
    FrameData[IUI_ActionBar] = {["IsMouseOn"] = false, ["InCombat"] = true, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = ActionButtons, ["Anchors"] = ActionBarAnchors}
    IUI_LoadBarsFrame()
    FrameData[IUI_Bars] = {["IsMouseOn"] = false, ["InCombat"] = false, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {StatusTrackingBarManager}, ["Anchors"] = BarAnchors}
    IUI_LoadMenusFrame()
    FrameData[IUI_Menus] = {["IsMouseOn"] = false, ["InCombat"] = false, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = MicroButtons, ["Anchors"] = MenuAnchors}
    IUI_LoadBagsFrame()
    FrameData[IUI_Bags] = {["IsMouseOn"] = false, ["InCombat"] = false, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = BagButtons, ["Anchors"] = BagAnchors}
    IUI_LoadMinimapCluster()
    FrameData[IUI_MiniMap] = {["IsMouseOn"] = false, ["InCombat"] = false, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {MinimapCluster, Minimap, Minimap:GetChildren()}, ["Anchors"] = MiniMapAnchors}
    IUI_LoadBuffsFrame()
    FrameData[IUI_Buffs] = {["IsMouseOn"] = false, ["InCombat"] = true, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {BuffFrame}, ["Anchors"] = BuffAnchors}
    IUI_LoadObjectiveTracker()
    FrameData[IUI_QuestTracker] = {["IsMouseOn"] = false, ["InCombat"] = false, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {ObjectiveTrackerFrame}, ["Anchors"] = QuestAnchors}
    IUI_LoadPartyFrame()
    FrameData[IUI_Party] = {["IsMouseOn"] = false, ["InCombat"] = true, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = PartyFrames, ["Anchors"] = PartyAnchors}
    -- opacity frames without an IUI anchor...
    FrameData[CompactRaidFrameManager] = {["IsMouseOn"] = false, ["InCombat"] = false, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {CompactRaidFrameManager}, ["Anchors"] = {}}
    FrameData[FocusFrame] = {["IsMouseOn"] = false, ["InCombat"] = true, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {FocusFrame}, ["Anchors"] = {}}
    for i,frame in pairs(PopFrames) do
        FrameData[frame] = {["IsMouseOn"] = false, ["InCombat"] = false, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {frame}, ["Anchors"] = {}}
    end
    --if IsAddOnLoaded("Details") then
        --FrameData[Details_WindowFrame1] = {["IsMouseOn"] = true, ["InCombat"] = true, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {Details_WindowFrame1}, ["Anchors"] = {}} 
    --end
    if IsAddOnLoaded("ImmersiveCharacterNeeds") then
        --print("ICN_HUDParent")
        FrameData[ICN_HUDParent] = {["IsMouseOn"] = true, ["InCombat"] = false, ["OnOpacity"] = OnOpacity, ["OffOpacity"] = OffOpacity, ["Frames"] = {ICN_HUDParent}, ["Anchors"] = {}}
    end
    -- set alpha and...
    for IUI_frame,Data in pairs(FrameData) do
        for i,frame in pairs(Data["Frames"]) do
            if frame == Minimap then
                if not IsIndoors() then
                    frame:SetAlpha(Data["OffOpacity"])
                end
            else
                frame:SetAlpha(Data["OffOpacity"])
            end
            -- if frame data hasn't been hooked then hook it...
            if not IsFrameDataHooked then
                frame:HookScript("OnShow", function(self) 
                    if (UnitAffectingCombat('player') and Data["InCombat"]) or MouseIsOver(IUI_frame) then
                        self:SetAlpha(Data["OnOpacity"])
                    else
                        self:SetAlpha(Data["OffOpacity"])
                    end 
                end)
            end
        end
    end
    if not IsFrameDataHooked then            
        IUI_Update = CreateFrame("Frame", nil, UIParent)
        IUI_Update:SetScript("OnUpdate", IUI_OnUpdate)
        IsFrameDataHooked = true
    end
end

-- sets tooltip to cursor correctly...
function SetTooltip(self)
	local scale = self:GetEffectiveScale()
    local x, y = GetCursorPosition()
    if not IUI_Account_Table['TOOLTIP']['USE_BORDER'] then
        self:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
            edgeFile = nil, 
            tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 0, right = 0, top = 0, bottom = 0 }});
        if GetMouseFocus() == WorldFrame then 
            self:SetBackdropColor(0,0,0,IUI_Account_Table['TOOLTIP']['WORLD_ALPHA'])
        else
            self:SetBackdropColor(0,0,0,IUI_Account_Table['TOOLTIP']['MENU_ALPHA'])
        end
    end
	self:ClearAllPoints()
    self:SetPoint("BOTTOMLEFT", UIParent, x / scale + 25, (y / scale - self:GetHeight() - 25))
end

function SetFrameAlpha(frame, speed, data, invsout)
    if frame:IsVisible() then
        if frame == Minimap then
            if IsIndoors() then
                frame:SetAlpha(1)
            else
                if invsout then
                    UIFrameFadeIn(frame, speed, frame:GetAlpha(), data["OnOpacity"])
                else
                    UIFrameFadeOut(frame, speed, frame:GetAlpha(), data["OffOpacity"])
                end
            end
        else
            if invsout then
                UIFrameFadeIn(frame, speed, frame:GetAlpha(), data["OnOpacity"])
            else
                UIFrameFadeOut(frame, speed, frame:GetAlpha(), data["OffOpacity"])
            end
        end
    end
end

function IUI_UpdateFrames()
    -- UPDATE BUFF AND PARTY FRAMES!!
    for IUI_frame,Data in pairs(FrameData) do
        -- check position and fix if necessery...
        --if IUI_frame == IUI_ActionBar then
        for frame,anchor in pairs(Data["Anchors"]) do
            if frame:GetPoint() ~= unpack(anchor) then
                --print(frame:GetName())
                frame:ClearAllPoints()
                if frame == ObjectiveTrackerFrame then
                    frame:SetAllPoints(IUI_QuestTracker)
                else
                    frame:SetPoint(unpack(anchor))
                end 
            end
        end
        -- if we are in combat...
        if UnitAffectingCombat('player') then
            if Data["InCombat"] then
                -- check if we have already set the opacity...
                if not Data["IsMouseOn"] then
                    -- iterate through default frames...
                    for i,frame in pairs(Data["Frames"]) do
                        -- setting their opacity...
                        SetFrameAlpha(frame, 0.25, Data, true)
                    end
                    -- flip the switch over memory saving bool...
                    Data["IsMouseOn"] = true
                end
            else
                -- if the mouse is over the frame...
                if MouseIsOver(IUI_frame) then
                    -- check if we have already set the opacity...
                    if not Data["IsMouseOn"] then
                        -- iterate through default frames...
                        for i,frame in pairs(Data["Frames"]) do
                            -- setting their opacity...
                            SetFrameAlpha(frame, 0.5, Data, true)
                        end
                         -- flip the switch over memory saving bool...
                         Data["IsMouseOn"] = true
                    end
                else
                    -- check if we have already set the opacity...
                    if Data["IsMouseOn"] then
                        -- iterate through default frames...
                        for i,frame in pairs(Data["Frames"]) do
                            -- setting their opacity...
                            SetFrameAlpha(frame, 0.5, Data, false)
                        end
                         -- flip the switch over memory saving bool...
                         Data["IsMouseOn"] = false
                    end
                end
            end
        -- if we are not in combat...
        else
            -- if the mouse is over the frame...
            if MouseIsOver(IUI_frame) then
                -- check if we have already set the opacity...
                if not Data["IsMouseOn"] then
                    -- iterate through default frames...
                    for i,frame in pairs(Data["Frames"]) do
                        -- setting their opacity...
                        SetFrameAlpha(frame, 0.5, Data, true)
                    end
                    Data["IsMouseOn"] = true
                end
            else
                -- check if we have already set the opacity...
                if Data["IsMouseOn"] then
                    -- iterate through default frames...
                    for i,frame in pairs(Data["Frames"]) do
                        -- setting their opacity...
                        SetFrameAlpha(frame, 0.5, Data, false)
                    end
                    Data["IsMouseOn"] = false
                end
            end
        end
    end
end

function IUI_UpdateChatOpacity()
    for i=1,NUM_CHAT_WINDOWS do
        --_G["ChatFrame"..i]:SetParent(_G["ChatFrame"..i.."EditBox"])
        if MouseIsOver(_G["ChatFrame"..i.."Tab"]) then
            if _G["ChatFrame"..i.."Tab"]:GetAlpha() ~= OnOpacity then
                _G["ChatFrame"..i.."Tab"]:SetAlpha(OnOpacity)
            end
        else
            if _G["ChatFrame"..i.."Tab"]:GetAlpha() ~= OffOpacity then
                _G["ChatFrame"..i.."Tab"]:SetAlpha(OffOpacity)
            end
        end
        if MouseIsOver(_G["ChatFrame"..i]) then
            if _G["ChatFrame"..i]:GetAlpha() ~= OnOpacity then
                _G["ChatFrame"..i]:SetAlpha(OnOpacity)
            end
        else
            if _G["ChatFrame"..i]:GetAlpha() ~= OffOpacity then
                _G["ChatFrame"..i]:SetAlpha(OffOpacity)
            end
        end
        if MouseIsOver(_G["ChatFrame"..i.."EditBox"]) then
            if _G["ChatFrame"..i.."EditBox"]:GetAlpha() ~= OnOpacity then
                _G["ChatFrame"..i.."EditBox"]:SetAlpha(OnOpacity)
            end
        else
            if _G["ChatFrame"..i.."EditBox"]:GetAlpha() ~= OffOpacity then
                _G["ChatFrame"..i.."EditBox"]:SetAlpha(OffOpacity)
            end
        end
        if MouseIsOver(_G["ChatFrame"..i.."ButtonFrame"]) then
            if _G["ChatFrame"..i.."ButtonFrame"]:GetAlpha() ~= OnOpacity then
                if i == 1 then
                    ChatFrameChannelButton:SetAlpha(OnOpacity)
                    ChatFrameMenuButton:SetAlpha(OnOpacity)
                end
                _G["ChatFrame"..i.."ButtonFrame"]:SetAlpha(OnOpacity)
            end
        else
            if _G["ChatFrame"..i.."ButtonFrame"]:GetAlpha() ~= OffOpacity then
                if i == 1 then
                    ChatFrameChannelButton:SetAlpha(OffOpacity)
                    ChatFrameMenuButton:SetAlpha(OffOpacity)
                end
                _G["ChatFrame"..i.."ButtonFrame"]:SetAlpha(OffOpacity)
            end
        end
    end
end

function IUI_OnUpdate(self, elapsed)
    if StatusTrackingBarManager.SingleBarLarge:GetWidth() ~= IUI_Bars:GetWidth() then
        IUI_LoadBarsFrame()
    end
    IUI_UpdateFrames()
    IUI_UpdateChatOpacity()
end
